码迷,mamicode.com
首页 > 其他好文 > 详细

LeetCode Problem 2:Two Sum

时间:2014-12-24 20:03:47      阅读:129      评论:0      收藏:0      [点我收藏+]

标签:

描述:

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

思路1:暴力搜索,两层循环。时间:O(n^2),空间:O(1),可能出现超时

思路2:考虑使用map或者hash_map,遍历输入的numbers,在map映射表中寻找target-numbers[i],C++ STL中map使用红黑树实现,查找元素时间O(logn),总时间O(nlogn)

 1 class Solution {
 2 public:
 3     vector<int> twoSum(vector<int> &numbers, int target) {
 4         
 5         vector<int> result;
 6         map<int, int> hashMap;
 7         
 8         for(int i = 0; i < numbers.size(); i++) {
 9             
10             if(!hashMap.count(numbers[i])) 
11                 hashMap.insert(pair<int,int>(numbers[i], i));   // <value, key>
12                 
13             if(hashMap.count(target - numbers[i]))  {
14                 int n = hashMap[target - numbers[i]];   //get the second number‘s position
15                 if(n < i)   {
16                     result.push_back(n + 1);
17                     result.push_back(i + 1);
18                     return result;
19                 }
20                 
21                 //unnecessary
22                 /*if(n > i)    {
23                     result.push_back(i + 1);
24                     result.push_back(n + 1);
25                     return result;
26                 }*/
27             }
28         }
29     }
30 };

 

附LeetCode建议解决方案

技术分享

LeetCode Problem 2:Two Sum

标签:

原文地址:http://www.cnblogs.com/fanyabo/p/4183158.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!